Attribute VB_Name = "ModuloRs232"
Option Explicit
' Funcin que crea un timer
Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
' Funcin que detiene el timer iniciado
Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long

Dim Buffer As String

Dim Retraso As Boolean  'Variable que indica que se cumplio el tiempo

' Funcin Callback que se dispara al iniciar el timer
Sub TimerProc(ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long)
    TimeOut = True
End Sub





Function AbrirPuerto(MostrarError As Boolean) As Boolean
On Error GoTo Rutina

'cerramos el puerto por si esta abierto
If frmMain.PuertoSerie.PortOpen Then frmMain.PuertoSerie.PortOpen = False

'Puerto a abrir
frmMain.PuertoSerie.CommPort = Puerto  'el numero del puerto
' 115200 baud, sin paridad, 8 bytes, y un bit de stop.
If Vel_RS232 = "" Then Vel_RS232 = "9600"
frmMain.PuertoSerie.Settings = Vel_RS232 & ",N,8,1"
' lectura completa del buffer
frmMain.PuertoSerie.InputLen = 0
' Abrimos el puerto
frmMain.PuertoSerie.PortOpen = True
'Flag indicador de que se ha abierto el puerto serie con exito
AbrirPuerto = True

Exit Function

Rutina:
AbrirPuerto = False

If MostrarError Then
    MsgBox Error & "... Abrir puerto", vbInformation, "Error"
End If
End Function

Sub CerrarPuertoSerie()
On Error GoTo Rutina
' Cerramos el puerto serie
frmMain.PuertoSerie.PortOpen = False

Rutina:
End Sub

'Timer de retraso para el envio de datos
Sub retraso15(ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long)
    Retraso = True
End Sub

'Lee las posicion del servo seleccionado
Function LeerPosicion(nServo As Integer, MostrarError As Boolean) As Byte
On Error GoTo Rutina

'Abre el puerto y si lo consigue lee las posiciones
If PuertoAbierto Then
    frmMain.PuertoSerie.Output = "P" & Chr$(nServo)
    
    
    'Creamos un timer de 15 ms para que se envien los datos
    SetTimer frmMain.hwnd, 0, 15, AddressOf retraso15
    Retraso = False
    While Retraso = False
        DoEvents
    Wend
    KillTimer frmMain.hwnd, 0
    
    Buffer = ""
    TimeOut = False
    
    'Encendemos el timer de timeout
    SetTimer frmMain.hwnd, 0, 300, AddressOf TimerProc
            
    'Esperamos a que se envien todos los datos
    While frmMain.PuertoSerie.OutBufferCount > 0 And TimeOut = False
        DoEvents
    Wend
    'Esperamos a que entren los datos
    While frmMain.PuertoSerie.InBufferCount = 0 And TimeOut = False
        DoEvents
    Wend
    
    Do
        DoEvents
        Buffer = frmMain.PuertoSerie.Input
        If Buffer <> "" Then
            LeerPosicion = Val(Asc(Buffer))
        End If
    Loop Until InStr(Buffer, vbCr) Or TimeOut = True
    
    'Matamos el timer de TimeOut
    KillTimer frmMain.hwnd, 0

    'Si se habilita el TimeOut puede ser porque no se detecta la placa
    If TimeOut Then
        If MostrarError Then
            MsgBox "Error de Time Out... Leer posicion", vbInformation, "Error"
        End If
    End If
End If

Exit Function

Rutina:
    MsgBox Error & "... Leer posicion", vbInformation, "Error"
End Function




Sub EnviarPosicion()
On Error GoTo Rutina

Dim CadenaEnvio As String
Dim tt As Integer
Dim TmpC As Integer

'Modo RS232
If ModoRS232 = RS232 And PuertoAbierto Then
    'Lanzamos al puerto el comando a los servos *************************************
    If PuertoAbierto Then
        Dim Buffer As String
        
        'Generamos la cadena de envio
        CadenaEnvio = "T"
        
        'Envio los valores de los servos en modo multiple
        For tt = 0 To 27
            CadenaEnvio = CadenaEnvio & Chr(frmMain.VS1(tt).Value)
        Next tt
        
        'Enviamos la posicion a los servos
        frmMain.PuertoSerie.Output = CadenaEnvio
        
    End If
End If

Exit Sub

Rutina:
    MsgBox Error & "... Enviar posicion", vbInformation, "Error"
End Sub
   


Sub EnviarPosicionServo(nServo As Integer, Posicion As Byte)
On Error GoTo Rutina

Dim CadenaEnvio As String
Dim t As Integer

'Modo RS232
If ModoRS232 = RS232 And PuertoAbierto Then
    'Lanzamos al puerto el comando a los servos *************************************
    If PuertoAbierto Then
        Dim Buffer As String
        
        'Enviamos la posicion a los servos
        frmMain.PuertoSerie.Output = "S" & Chr$(nServo) & Chr$(Posicion)
    End If
End If

Exit Sub

Rutina:
    MsgBox Error & "... Enviar posicion Servo", vbInformation, "Error"
End Sub



Sub EnviarComandoDeInicio(nServo As Integer, Posicion As Byte)
On Error GoTo Rutina

If ModoRS232 = RS232 And PuertoAbierto Then
    'Lanzamos al puerto el comando a los servos *************************************
    If PuertoAbierto Then
        
        frmMain.PuertoSerie.Output = "I" & Chr$(nServo) & Chr(Posicion)
        
        Buffer = ""
        TimeOut = False
        
        'Encendemos el timer de timeout
        SetTimer frmMain.hwnd, 0, 300, AddressOf TimerProc
                
        'Esperamos a que se envien todos los datos
        While frmMain.PuertoSerie.OutBufferCount > 0 And TimeOut = False
            DoEvents
        Wend
        'Esperamos a que entren los datos
        While frmMain.PuertoSerie.InBufferCount = 0 And TimeOut = False
            DoEvents
        Wend
                
        Do
            DoEvents
            Buffer = frmMain.PuertoSerie.Input
        Loop Until InStr(Buffer, vbCr) Or TimeOut = True
        
        'Matamos el timer de TimeOut
        KillTimer frmMain.hwnd, 0

        If TimeOut Then
            MsgBox "Error de Time Out en el comando de inicio", vbInformation, "Error"
        End If
    End If
End If

Exit Sub

Rutina:
    MsgBox Error & "... Enviar comando de inicio", vbInformation, "Error"
End Sub






Sub VelocidadRS232(Velocidad As Integer)
On Error GoTo Rutina

Dim CadenaEnvio As String
Dim t As Integer

'Modo RS232
If ModoRS232 = RS232 And PuertoAbierto Then
    'Lanzamos al puerto el comando a los servos *************************************
    If PuertoAbierto Then
        Dim Buffer As String
        
        'Enviamos la posicion a los servos
        frmMain.PuertoSerie.Output = "A" & Chr$(Velocidad)
        
        Buffer = ""
        TimeOut = False
        
        'Encendemos el timer de timeout
        SetTimer frmMain.hwnd, 0, 300, AddressOf TimerProc
                
        Do
            DoEvents
            Buffer = frmMain.PuertoSerie.Input
        Loop Until InStr(Buffer, vbCr) Or TimeOut = True
        
        'Matamos el timer de TimeOut
        KillTimer frmMain.hwnd, 0
        
        If TimeOut Then
            MsgBox "Error de Time Out enviando la velocidad al puerto serie", vbInformation, "Error"
        End If
    End If
End If

Exit Sub

Rutina:
    MsgBox Error & "... Enviando velocidad de inicio", vbInformation, "Error"
End Sub




